/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Cancer class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>

#include "EntityContainer.h"
#include "StarFighter.h"


#ifndef BLOB_H
#define BLOB_H

//------------------------------------------------------------------------------
//	Blob Enemy
//------------------------------------------------------------------------------
class Blob {

public:
	friend class BlobContainer;
	
	Blob();
	~Blob();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	s32		Sx;
	int		Radius;
	int		Frame;
	int 	Counter;
	bool	Active;

	EN_DRAW_MODE DrawMode;

};

//------------------------------------------------------------------------------
//	Blob Container
//------------------------------------------------------------------------------
class BlobContainer : public EntityContainer
{	

public:

	BlobContainer( int Palette, glImage* const Sprites );
    ~BlobContainer();
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	void Spawn(  int _x, int _y, s32 speed, int _radius );
	
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Blob> Blobs;
	
	
};

#endif // BLOB_H
