/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Centipede class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>
#include <cstdio>

#include "EntityContainer.h"
#include "StarFighter.h"
#include "Vector2df32.h"
#include "Spline.h"
#include "cearn_atan.h"
#include "spline_centipede.h"


#ifndef CENTIPEDE_H
#define CENTIPEDE_H

#define CENTIPEDE_MAX_SEGMENTS 64

//------------------------------------------------------------------------------
//	Centipede Enemy
//------------------------------------------------------------------------------
class Centipede {

public:
	friend class CentipedeContainer;
	
	Centipede();
	~Centipede();
	void Update();
	
private:

	
	s32		x;
	s32		y;
	s32		ox;
	s32		oy;
	int 	Index;
	int		Frame;
	int 	Counter;
	bool	Active;
	
	EN_DRAW_MODE DrawMode;

	Vector2df32 Segments[CENTIPEDE_MAX_SEGMENTS];
	Vector2df32 *Path;
	
};

//------------------------------------------------------------------------------
//	Centipede Container
//------------------------------------------------------------------------------
class CentipedeContainer : public EntityContainer
{	

public:

	CentipedeContainer( int Palette, glImage* const Sprites );
    ~CentipedeContainer();
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	void Spawn(  int _x, int _y  );
	
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Centipede> Centipedes;
	
	
};

#endif // CENTIPEDE_H
