/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Metroid class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>

#include "EntityContainer.h"
#include "StarFighter.h"

#ifndef METROID_H
#define METROID_H

//------------------------------------------------------------------------------
//	Metroid Class
//------------------------------------------------------------------------------
class Metroid 
{

public:
	friend class MetroidContainer;
	
	Metroid();
	~Metroid();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	s32		Sy;
	int 	Radius;
	int		Frame;
	int 	Counter;
	bool	Active;
	
	EN_DRAW_MODE DrawMode;
};


//------------------------------------------------------------------------------
//	Metroid Container
//------------------------------------------------------------------------------
class MetroidContainer : public EntityContainer
{	

public:

	MetroidContainer( int Palette, glImage* const Sprites );
    ~MetroidContainer();
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	void Spawn(  int _x, int _sy, s32 speed, int _radius );
	
	virtual int NumEntities() 
	{
		return numEntities;
	}
private:
	
	glImage *Images;
	int ColorTable;
	int numEntities;
	std::vector<Metroid> Metroids;
	
	
};

#endif // METROID_H
