/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	RotoSpark class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>

#include "Vector2df32.h"
#include "EntityContainer.h"
#include "StarFighter.h"


#ifndef ROTOSPARK_H
#define ROTOSPARK_H

//------------------------------------------------------------------------------
//	RotoSpark Enemy
//------------------------------------------------------------------------------
class RotoSpark 
{

public:
	friend class RotoSparkContainer;
	
	RotoSpark();
	~RotoSpark();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	int 	RotDir;
	int		Frame;
	int 	Counter;
	bool	Active;


};

//------------------------------------------------------------------------------
//	RotoSpark Container
//------------------------------------------------------------------------------
class RotoSparkContainer : public EntityContainer
{	

public:

	RotoSparkContainer( int Palette, glImage* const Sprites );
    ~RotoSparkContainer();
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	void Spawn( int _x, int _y, bool reverse = false );
	
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<RotoSpark> RotoSparks;
	
	
};

#endif // ROTOSPARK_H
