/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Utilities


*******************************************************************************
******************************************************************************/

#ifndef UTIL_H
#define UTIL_H

namespace UTIL
{

//--------------------------------------
//	
//--------------------------------------
#define RGB15_R(u) ( ((u) >> 0  ) & 0x001F )
#define RGB15_G(u) ( ((u) >> 5  ) & 0x001F )
#define RGB15_B(u) ( ((u) >> 10 ) & 0x001F )


//--------------------------------------
//	
//--------------------------------------
static inline s32 Lerp( s32 start, s32 end, s32 t )
{
	
	s32 d = ( end - start );
	return ( start + mulf32( d,t ) );
	
}


//--------------------------------------
//	
//--------------------------------------
static inline int Clamp( int in, int mins, int maxs )
{
	if( in < mins )
		in = mins;
	if( in > maxs )
		in = maxs;
	return in;
}


//--------------------------------------
//	
//--------------------------------------
static inline int Wrap( int in, int maxs )
{
	if( in > maxs )
		in -= maxs ;
	if( in < 0 )
		in += maxs;
	return in;
}


}  // end namespace

#endif // UTIL_H
